#!/usr/bin/perl
#
# junky script to add binary data to a swf
# usage: PutBIN.pl src.swf dst.swf data.bin symname
#
# ADOBE SYSTEMS INCORPORATED
# Copyright 2008 Adobe Systems Incorporated. All Rights Reserved.
#
# NOTICE:  Adobe permits you to use, modify, and distribute this file in
# accordance with the terms of the Adobe license agreement accompanying it.
# If you have received this file from a source other than Adobe, then your use,
# modification, or distribution of it requires the prior written permission of Adobe.
#

open(BIN, $ARGV[2]);
undef $/;
$bin = <BIN>;
close(BIN);
open(OUT, ">$ARGV[1]");
open(SWF, $ARGV[0]);
binmode(SWF);
binmode(OUT);

# skip hash-bang
read(SWF, $byte0, 1);

if($byte0 eq '#')
  { <SWF> } # read the line
else
  { seek(SWF, 0, 0) }

read(SWF, $head, 8);

if(substr($head, 0, 1) eq 'C')
{
  substr($head, 0, 1) = 'F';
  $temp = "$$.achacks.S";
  $use_zpipe = qx/which zpipe/;
  if($use_zpipe) {
    sys("zpipe", "<$SWF", ">$temp");
  }
  else {
    sys("zpipe.pl", "<$SWF", ">$temp");
  }
  close(SWF);
  open(SWF, "<$temp");
  binmode(SWF);
}

print OUT $head;

read(SWF, $rect1, 1);
print OUT $rect1;
$rbits = unpack("C", $rect1) >> 3;
$rrbytes = int((7 + ($rbits * 4) - 3) / 8);
read(SWF, $rectr, $rrbytes);
print OUT $rectr;
read(SWF, $frameRate, 2);
print OUT $frameRate;
print "frame rate: " . unpack("v", $frameRate) / 256.0 . "\n";
read(SWF, $frameCount, 2);
print OUT $frameCount;
print "frame count: " . unpack("v", $frameCount) . "\n";

do
{
  read(SWF, $code, 2);
  print OUT $code;
  $code = unpack("v", $code);
  $tag = $code >> 6;
  $len = ($code & 0x3f);
  $bhead = 2;
  if($len == 0x3f)
  {
    read(SWF, $len, 4);
    print OUT $len;
    $len = unpack("V", $len);
    $bhead += 4;
  }
  print "$tag : $len\n";
  read(SWF, $data, $len);
  print OUT $data;
  if(!$done && ($tag == 72 || $tag == 82)) # DoABC || DoABC2
  {
    $id = $ARGV[4] || 34;
    print "putting data ($id) : " . length($bin) . "\n";
    $code = (87 << 6) | 0x3f; # binary
    print OUT pack("vVvV", $code, length($bin) + 2 + 4, $id, 0);
    print OUT $bin;
    $sym = pack("vvZ*", 1, $id, $ARGV[3]);
    $code = (76 << 6) | 0x3f; # symbol
    print OUT pack("vV", $code, length($sym));
    print OUT $sym;
    $done = 1;
  }
} while($tag != 0);
do
{
  read(SWF, $rest, 1);
  print OUT $rest;
} while(length($rest));
$swflen = tell(OUT);
seek(OUT, 4, 0);
print OUT pack("V", $swflen);
if($temp)
  { system("rm", $temp) }
